from admit.at import *
import xml.etree.cElementTree as et
from xmlio.DtdReader import DtdReader
import os.path
import admit.xmlio.Parser as Parser
import zipfile
#import admit.FlowManager

class Admit(object):
    def __init__(self,baseDir = os.getcwd()):
        self.tasks = []
        self.userData = {}
        self.baseDir = None
        self.baseFile = None
        #self.flowmanager = FlowManager.FlowManager()   ### need to add to xml
        self.new = False
        if(os.path.exists(baseDir)):
            if(os.path.isfile(baseDir)):
                loc = baseDir.rfind(os.sep)
                if(loc == -1):
                    self.baseDir = ""
                    self.baseFile = baseDir
                else:
                    self.basedir = baseDir[:loc+1]
                    self.baseFile = baseDir[loc+1:]
            elif(os.path.isdir(baseDir)):
                if(baseDir[-1] == os.sep) :
                    self.baseDir = baseDir
                    self.baseFile = "admit.xml"
                else:
                    self.baseDir = baseDir + os.sep
                    self.baseFile = "admit.xml"
                self.new = not os.path.exists(self.baseDir + self.baseFile)
            if(zipfile.is_zipfile(self.baseDir + self.baseFile)):
                with zipfile.ZipFile(self.baseDir + self.baseFile,'r') as z:
                    z.extractall(self.basedir)
                if(not os.path.exists(self.basedir + "admit.xml")):
                    raise Exception, "No admit.xml file located"
                self.baseFile = "admit.xml"
        else :
            self.new = True
            self.baseDir = baseDir
            self.baseFile = "admit.xml"
        if(not self.new):
            parser = Parser.Parser(self.baseDir,self.baseFile)
            parser.parse()
            self.tasks = parser.getTasks()         # need to implement
            self.userData = parser.getUserData()   # need to implement
        
    def read(self):
        pass
    
    def addTask(self,task):
        self.tasks.append(task)
    
    def write(self):
        dtdRead = DtdReader("admit.dtd")
        dtd = dtdRead.getDtd()

        root = et.Element("ADMIT")

        node = et.SubElement(root,"userData")
        node.set("type","DICT")
        node.set("ndarray","0")
        node.text = str(self.userData)
        for i in self.tasks:
            root = i.write(root)
        rough_string = et.tostring(root, 'utf-8')


        temp = rough_string.replace(">",">\n")
        temp = temp.replace("</","\n</")

        outFile = open(self.baseDir + "admit.xml",'w')
        outFile.write("<?xml version=\"1.0\" ?>\n")

        # write out the dtd info at the top
        outFile.write("<!DOCTYPE ADMIT [\n\n")
        for line in dtd :
            outFile.write(line)
        outFile.write("]>\n\n")
        outFile.write(temp)

        outFile.close()
        for i in self.tasks :
            i.save()
            i.markUpToDate()
