"""
This file contains a registry of all BDP classes, and is used by the dtd generator and xml parser

If a new BDP is created then the following must be added to this file:

from <BDP FILE> import <BDP CLASS>

add to BDPTYPES:
"<BDP FILE>": <BDP CLASS NAME>(),

@todo   how to add a parallel branch when not CASA AT's used, but MIRIAD AT's
        or radio_astro_tools AT's
"""

from admit.bdp.CubeStats_BDP           import CubeStats_BDP
from admit.bdp.Summary_BDP             import Summary_BDP
from admit.bdp.SpwCube_BDP             import SpwCube_BDP
from admit.bdp.SpectralMap_BDP         import SpectralMap_BDP
from admit.bdp.PvSlice_BDP             import PvSlice_BDP
from admit.bdp.PvCorr_BDP              import PvCorr_BDP
from admit.bdp.PeakPointPlot_BDP       import PeakPointPlot_BDP
from admit.bdp.OverlapIntegral_BDP     import OverlapIntegral_BDP
from admit.bdp.Moment_BDP              import Moment_BDP
from admit.bdp.LineCube_BDP            import LineCube_BDP
from admit.bdp.LineList_BDP            import LineList_BDP
from admit.bdp.FeatureList_BDP         import FeatureList_BDP
from admit.bdp.CubeSpectrum_BDP        import CubeSpectrum_BDP
from admit.bdp.ContinuumMap_BDP        import ContinuumMap_BDP
from admit.bdp.CubeSum_BDP             import CubeSum_BDP
from admit.bdp.DescriptionVector_BDP   import DescriptionVector_BDP
#from admit.bdp.test.Test_BDP           import Test_BDP

from admit.at.CubeStats_AT         import CubeStats_AT
from admit.at.Summary_AT           import Summary_AT
from admit.at.SpwCube_AT           import SpwCube_AT
from admit.at.SpectralMap_AT       import SpectralMap_AT
from admit.at.PvSlice_AT           import PvSlice_AT
from admit.at.PvCorr_AT            import PvCorr_AT
from admit.at.PeakPointPlot_AT     import PeakPointPlot_AT
from admit.at.OverlapIntegral_AT   import OverlapIntegral_AT
from admit.at.Moment_AT            import Moment_AT
from admit.at.LineCube_AT          import LineCube_AT
from admit.at.LineList_AT          import LineList_AT
from admit.at.FeatureList_AT       import FeatureList_AT
from admit.at.CubeSpectrum_AT      import CubeSpectrum_AT
from admit.at.ContinuumMap_AT      import ContinuumMap_AT
from admit.at.CubeSum_AT           import CubeSum_AT
from admit.at.DescriptionVector_AT import DescriptionVector_AT

BDPTYPES = {"CubeStats_BDP":        CubeStats_BDP(),
            "Summary_BDP":          Summary_BDP(),
            "SpwCube_BDP":          SpwCube_BDP(),
            "SpectralMap_BDP":      SpectralMap_BDP(),
            "PvSlice_BDP":          PvSlice_BDP(),
            "PvCorr_BDP":           PvCorr_BDP(),
            "PeakPointPlot_BDP":    PeakPointPlot_BDP(),
            "OverlapIntegral_BDP":  OverlapIntegral_BDP(),
            "Moment_BDP":           Moment_BDP(),
            "LineCube_BDP":         LineCube_BDP(),
            "LineList_BDP":         LineList_BDP(),
            "FeatureList_BDP":      FeatureList_BDP(),
            "CubeSpectrum_BDP":     CubeSpectrum_BDP(),
            "ContinuumMap_BDP":     ContinuumMap_BDP(),
            "CubeSum_BDP":          CubeSum_BDP(),
            "DescriptionVector_BDP":DescriptionVector_BDP(),
#            "Test_BDP":             Test_BDP(),
}

ATTYPES = { "CubeStats_AT":        CubeStats_AT(),
            "Summary_AT":          Summary_AT(),
            "SpwCube_AT":          SpwCube_AT(),
            "SpectralMap_AT":      SpectralMap_AT(),
            "PvSlice_AT":          PvSlice_AT(),
            "PvCorr_AT":           PvCorr_AT(),
            "PeakPointPlot_AT":    PeakPointPlot_AT(),
            "OverlapIntegral_AT":  OverlapIntegral_AT(),
            "Moment_AT":           Moment_AT(),
            "LineCube_AT":         LineCube_AT(),
            "LineList_AT":         LineList_AT(),
            "FeatureList_AT":      FeatureList_AT(),
            "CubeSpectrum_AT":     CubeSpectrum_AT(),
            "ContinuumMap_AT":     ContinuumMap_AT(),
            "CubeSum_AT":          CubeSum_AT(),
            "DescriptionVector_AT":DescriptionVector_AT(),
            }
